'
'
' csv2tsrc - csv to Tile Source (looks for x3tiles.csv and generates x3tiles.usr in the current (CF) sub-folder)
'
' 
'
' subroutine removes next value$ from in$
DECLARE SUB getnext(in$, val$)
'
version$="csv2tsrc - csv to Tile Source - Ver 1.0 2017-02-16 13:13"
'
' OK lets get started
'

'
PRINT version$
' NOTE QBasic can only deal for file name 8.3 (so .usr, not .usrc)
OPEN "C:\QBASIC\CF\x3tiles.csv" FOR INPUT AS #1
OPEN "C:\QBASIC\CF\x3tiles.tsr" FOR OUTPUT AS #2
' New log (will overwrite previous)
OPEN "C:\QBASIC\CF\csv2tsrc.log" FOR OUTPUT AS #4
'
'start the log
PRINT #4, "Logfile (.log) ";version$
'
' output the header
PRINT #2, "[tileset]"
PRINT #2, "name = x3tiles"
PRINT #2, "icons = CFTiles.bmp"
PRINT #2, "class0 = 30"
PRINT #2, "class1 = 81"
PRINT #2, "class2 = 117"
PRINT #2, "class3 = 150"
PRINT #2, "class4 = 250"
PRINT #2, "class5 = 360"
PRINT #2, "class6 = 362"
PRINT #2, "class7 = 361"
PRINT #2, "class8 = 178"
PRINT #2, "class9 = 148"
'
' Typical entry is :-
'# 031: plains [slightly rugged]
'[tile]
'terrain = plains
'icon = 25
'attack = 1
'defend = 1
'move = 2
'color = 94,142,52
'
'
' read the csv coulmn headings
' What we extect is:-
'serial,description,icon,attack,defend,move,shop,road,rails,plains,forest,mountains,swamp,water,shallowwater,deepwater,rough,trenches,restricted,hills,color
' Note -hills- added for compatability with code changes (is safe, since not used by any existing tile)
LINE INPUT #1, csvhead$
PRINT #4, "Reading column definitions, found:"
PRINT #4, csvhead$
' The first 2 fields are serial,description (just discard)
CALL getnext(csvhead$, val$)
CALL getnext(csvhead$, val$)
' The next 4 (icon,attack,defend,move) ending 'shop', are 'name = '
spos%=INSTR(csvhead$,"shop")
nameset$=LEFT$(csvhead$,spos%-1)
PRINT #4, "nameset headers = ";nameset$
csvhead$=MID$(csvhead$,spos%)
' All up to 'color' are terrain=
spos%=INSTR(csvhead$,"color")
terrainset$=LEFT$(csvhead$,spos%-1)
PRINT #4, "terrainset headers = ";terrainset$
' we don't care what's left, so that's it
'
' OK lets read the csv defs
DO
LINE INPUT #1, in$
PRINT #4, ""
PRINT #4, "Line input is: {";in$;"}"
' skip blank lines
IF in$ = "" THEN GOTO skip0
' start the tile
PRINT #2, ""
' get first value (serial)
CALL getnext(in$, val$)
ct%=LEN(val$)
' must be at least 1 digit
IF ct% = 0 THEN GOTO skip0
' pad to 3 digits
IF ct% = 1 THEN val$="00"+val$
IF ct% = 2 THEN val$="0"+val$
PRINT #4, "Serial = "+val$
' start building tag (comment) line
tag$="# "+val$+": "
' next field is description
CALL getnext(in$, val$)
' output with tag
PRINT #2, tag$+val$
' now start the tile proper
PRINT #2, "[tile]"
' 
' do the name= set
names$=nameset$
nxtname:
' get name
CALL getnext(names$, nval$)
' get value
CALL getnext(in$, val$)
' outpt (unless blank)
IF val$<>"" THEN PRINT #2, nval$+" = "+val$
' loop unless done
IF LEN(names$) > 1 THEN GOTO nxtname
PRINT #4, "all names done, remaining input is: {";in$;"}"
' 
' now it's the terrain set
terrain$=terrainset$
moret:
' get terrain=
CALL getnext(terrain$, ttype$)
' get value
CALL getnext(in$, val$)
' output (unless blank)
IF val$<>"" THEN PRINT #2, "terrain = "+ttype$
' loop unless att terrain manes done
IF LEN(terrain$) > 1 THEN GOTO moret
PRINT #4, "all terrain done, remaining input is: {";in$;"}"
'
' right, that takes us to last 3 values == color
CALL getnext(in$, val1$)
CALL getnext(in$, val2$)
CALL getnext(in$, val3$)
PRINT #2, "color = "+val1$+","+val2$+","+val3$
' thats it
'
skip0:
LOOP UNTIL EOF(1)

' all done, exit
PRINT #4, "Processing complete"
CLOSE

' subroutine chops next field (val$) off front of in$
SUB getnext (in$, val$)
val$=""
' find start of next field (might not be one)
cpos% = INSTR(in$, ",")
IF cpos% = 0 THEN val$=in$
IF cpos% > 1 THEN val$=LEFT$(in$,cpos%-1) 
' remove field
in$=MID$(in$,cpos%+1)
END SUB



