@echo off
echo CF Units, Tiles and Maps MAKE.CMD version 1.0 2017-02-16 10:30
echo EXISTING .tiles, .units and .lev FILES WILL BE OVERWRITTEN
echo
echo For qbasic to run, these files and subfolders must be in the qbasic/ folder
::
:: This MAKE.CMD file starts by rebuilding the .units and .tiles files
:: It then searches ./mapdource for .src files and 'complies' each one to a .lev
:: EXISTING FILES ARE OVERWRITTEN
:: start by asking the user for the source folder
::
:top
set makedir=.
set /p makedir= "Enter full path to the root of mapsource x3defs and tools folder, press return to use .\, or abort"
echo using source dir: '%makedir%'
:: if x3units.csv exists, generate new x3units.usrc
if exist %makedir%\x3defs\x3units.csv (
	:: tell user
	echo found %makedir%\x3defs\x3units.csv, attempting rebuild of usrc file
	echo WARNING: qbasic will only run if this .cmd is in same fodler as qbasic.exe
	copy %makedir%\x3defs\x3units.csv  c:\qbasic\CF\
	:: process the csv
	C:\qbasic\qbasic /run C:\qbasic\csv2usrc.bas
	:: get the result
	copy c:\qbasic\CF\x3units.usr %makedir%\x3defs\x3units.usrc
)
:: check we have unit source
if not exist %makedir%\x3defs\x3units.usrc (
	echo Unable to find %makedir%\x3defs\x3units.usrc, aborting
	pause
	goto:eof
)
:: OK we have x3units source, do the compile
echo Making unit set (output is x3units.units)
mkunitset .\x3defs\x3units.usrc .\x3defs\x3units.units .\x3defs
if not exist %makedir%\x3defs\x3units.units (
	echo Unable to find compiled x3units.units, aborting
	pause
	goto:eof
)
:: same for tiles
echo Now processing tiles source
if exist %makedir%\x3defs\x3tiles.csv (
	:: tell user
	echo found %makedir%\x3defs\x3tiles.csv, rebuilding tsrc file
	echo WARNING: qbasic will only run if this .cmd is in same fodler as qbasic.exe
	copy %makedir%\x3defs\x3tiles.csv  c:\qbasic\CF\
	:: process the csv
	C:\qbasic\qbasic /run C:\qbasic\CSV2TSRC.BAS
	:: get the result
	copy c:\qbasic\CF\x3tiles.tsr %makedir%\x3defs\x3tiles.tsrc
)
:: check we have unit source
if not exist %makedir%\x3defs\x3tiles.tsrc (
	echo Unable to find %makedir%\x3defs\x3tiles.tsrc, aborting
	pause
	goto:eof
)
:: OK we have x3tiles source, do the compile
echo Making tiles set (output is x3tiles.tiles)
mktileset .\x3defs\x3tiles.tsrc .\x3defs\x3tiles.tiles .\x3defs
if not exist %makedir%\x3defs\x3tiles.tiles (
	echo Unable to find compiled x3tiles.tiles, aborting
	pause
	goto:eof
)
:: OK we have units and tiles, lets go for the maps
echo x3units.units and x3tiles.tiles found OK, now building map.src
::
:: start with a list of the map files to process
dir /b %makedir%\mapsource\*.src > dir.tmp
:: for each file found, process using cfed
echo .lev files will be placed in .\mapsource folder
FOR /F  "delims=" %%G IN (dir.tmp) DO (
	echo Starting build of %%G
	cfed .\mapsource\%%G --tiles .\x3defs\x3tiles.tiles --units .\x3defs\x3units.units
)
:: OK thats all
ECHO All Map src done
pause
goto:eof
